/**
 * @file    GoGdpSignal.cs
 *
 * @internal
 * Copyright (C) 2022-2023 by LMI Technologies Inc.
 * Licensed under the MIT License.
 * Redistributed files must retain the above copyright notice.
 */
namespace GoPxLSdk.GoGdpMsg
{
    public class GoGdpSignal : GoGdpMsg
    {
        /// <summary>Constructs GoGdpSignal.</summary>
        internal GoGdpSignal()
            : base(MessageType.Signal)
        { }


        /// <summary>Deserialize void message.</summary>
        /// <param name="serializer">The serializer to read.</param>
        /// <exception cref="ArgumentOutOfRangeException">Thrown if failed to deserialize signal message.</exception>
        internal override void Deserialize(GoBinaryReader serializer)
        {
            base.Deserialize(serializer);

            serializer.BeginRead<ushort>(true);
            serializer.EndRead();
        }
    }
}