/**
 * @file    Utils.cs
 *
 * @internal
 * Copyright (C) 2022-2023 by LMI Technologies Inc.
 * Licensed under the MIT License.
 * Redistributed files must retain the above copyright notice.
 */
namespace GoPxLSdk.GoGdpMsg
{
    internal static class Utils
    {
        public static string ReadText(GoBinaryReader serializer, ushort numCharsToRead)
        {
            if (numCharsToRead > 0)
            {
                byte[] buffer = serializer.ReadBytes(numCharsToRead);
                string text = System.Text.Encoding.UTF8.GetString(buffer, 0, buffer.Length);
                return text;
            }

            return null;
        }
    }
}
